include('FPGAburn/serload.asm') # must be on the first line

# play with a 12-bit digital controlled oscillator
# a squarewave output is available on Pmod-4, Pmod-5 is GND
# one may also generate a sawtooth output by connecting msbs of pout_o to a DAC
# see TigerSOC.pcf

  lit(fwd('init')); jmp() # avoid some of fwd() hell
  
lbl('phacc'); data([0]) # phase accumulator
lbl('phinc'); data([0]) # phase increment

lbl('echo') # keystroke ->
  lit(tx_status); ld(); lit(echo)
  jz(); lit(uart); st()
  ret()

lbl('got_plus') # increment phinc
  lit(phinc); ld(); inc()
  lit(phinc); st(); ret()

lbl('got_minus') # decrement phinc
  lit(phinc); ld(); lit(ALLBITS)
  add(); lit(phinc); st()
  ret()

lbl('got_upoctave') # double phinc
  lit(phinc); ld(); tt()
  add(); lit(phinc); st()
  ret()

lbl('got_downoctave') # halve phinc
  lit(phinc); ld(); asr()
  lit(MAXPOS); band(); lit(phinc)
  st(); ret()

lbl('command') # respond to USB/UART keystrokes
  lit(rx_status); ld(); lit(fwd('no_command')); jz()
    lit(uart); ld(); tt(); tt() # -> keystroke keystroke keystroke
    lit(echo); call()
    # resolve defined keystroke commands
    lit(ord('-')); bxor(); lit(got_minus); jz()
    lit(ord('+')); bxor(); lit(got_plus); jz()
    lit(ord('<')); bxor(); lit(got_upoctave); jz()
    lit(ord('>')); bxor(); lit(got_downoctave); jz()
lbl('no_command')
  ret()

lbl('init')
  lit(1); lit(phinc); st()
lbl('doit') # main loop, 22 clks
    lit(command); call() # user control of phinc, nominal 8 clks
    lit(phacc); ld(); lit(phinc) # 4 clks
    ld(); add(); tt() # 3 clks
    lit(phacc); st(); lit(pio) # 4 clks
    st(); lit(doit); jmp() # 3 clks
# fs = fclk/22
# fout = fs*phinc/2**12
#      = 133.1676 Hz, phinc = 1

lbl('app_end') # must be on the last line