`timescale 1ns / 1ns

module TigerSOC_tb;

// inputs
reg clk_i;
reg rst_i;
reg [11:0] pin_i;

// outputs
wire call_overflow_o;
wire ret_underflow_o;
wire [11:0] pout_o;

TigerSOC uut (
  .clk_i(clk_i),
  .rst_i(rst_i),
  .pin_i(pin_i),
  .call_overflow_o(call_overflow_o),
  .ret_underflow_o(ret_underflow_o),
  .pout_o(pout_o)
);

parameter PERIOD = 2;

always begin
  clk_i = 0;
  #(PERIOD / 2);
  clk_i = 1;
  #(PERIOD / 2);
end

initial begin
  $timeformat(-9, 0, " cp/2", 9);
  rst_i = 1; // 0
  pin_i = 12'h123;
  #(PERIOD *2);

  rst_i = 0; // 4
  #(PERIOD * 20000000); // for blink.asm
//  #(PERIOD * 100); // for call_ov.asm and return_uf.asm

  $display("end time is %d cp/2", $stime);
  $finish;
end

// Icarus Verilog text output
initial
  $monitor("t %t, rst_i = %h, pin_i = %h, call_of_o = %h, ret_uf_o = %h, pout_o = %h",
            $time,
	    rst_i,
	    pin_i,
            call_overflow_o,
            ret_underflow_o,
	    pout_o
	    );
endmodule

