// read data mux

module readmux (
  input pio_i,
  input [11:0] pin_i,
  input timer_high_i,
  input timer_low_i,
  input [23:0] timer_i,
  input rx_status_i,
  input rx_ready_i,
  input tx_status_i,
  input tx_ready_i,
  input uart_i,
  input [7:0] rx_byte_i,
  input [11:0] RAM_dat_i,
  output [11:0] dat_o
);

reg [11:0] read_data;
assign dat_o = read_data;
always @* begin
  read_data = RAM_dat_i; // default
  // mutually-exclusive special cases
  if (pio_i) read_data = pin_i;
  if (timer_high_i) read_data = timer_i[23:12];
  if (timer_low_i) read_data = timer_i[11:0];
  if (rx_status_i) read_data = {12{rx_ready_i}};
  if (tx_status_i) read_data = {12{tx_ready_i}};
  if (uart_i) read_data = {4'h0, rx_byte_i};
end

endmodule

